  /*****************************************************************/
  /* NAME:  source2                                                */
  /*                                                               */
  /* DESCRIPTION:                                                  */
  /*                                                               */
  /*                                                               */
  /*                                                               */
  /* PRODUCT:  HR Vision                                           */
  /*                                                               */
  /* USAGE: %source2(dsname=,                                      */
  /*                 password=,                                    */
  /*                 datevar=,                                     */
  /*                 subset=,                                      */
  /*                 sortids=,                                     */
  /*                  );                                           */
  /*                                                               */
  /* Note:  The functionality of this macro has change a bunch     */
  /* since it was first developed.  It now justs sorts and subsets */
  /* the table by the supplied subset.  It probably should now     */
  /* should be called something like SUBSORT                       */
  /*****************************************************************/
 %macro source2(dsname=,
                password=,
                datevar=,
                sortids=,
                subset=,
                index=
                );
 
   %let dsname=%upcase(&dsname);
   %let datevar=%upcase(&datevar);
   %let sortids=%upcase(&sortids);
   %let index=%qupcase(&index);
 
   %local dsnamep i word;
   %global bldctoff;
   %if &password ne %then %let dsnamep=&dsname(read=&password);
   %else %let dsnamep=&dsname;
  
   /* check the existence of the date variable.  Blank out the subset */
   /* if necessary */
   %if &datevar ne %then %do;
     data _null_;
       dsid=open("&dsnamep");
       if dsid then do;
         if varnum(dsid,"&datevar") gt 0 then do;
           call symput('SUBSET',"&subset");
           put "NOTE: &dsname contains &datevar.. ";
           put "NOTE: Data effective after &bldctoff will be removed.";
         end;
         else do;
           call symput('SUBSET',' ');
           put "NOTE: &dsname does not contain &datevar..";
         end;
         dsid=close(dsid);
       end;
     run;
   %end;
 
   %if &sortids ne %then %do;
     %put NOTE: Sorting &dsname by &sortids..;
     /* Sort table by key field(s) */
      proc sort data=&dsname(&datapass) out=&dsname(&datapass) force;
       by &sortids;
       &subset
     run;
   %end;
   
   %if %bquote(&index) ne %then %do;
     %let i=1;
     %let word=%qscan(&index,&i,%str( ,));
     proc sql; 
 	  %do %while(&word ne );
 	    %str(create index &word on &dsname(&datapass);) 	
 	    %let i=%eval(&i+1);
 	    %let word=%qscan(&index,&i);
       %end;
     quit;
   %end; 
%mend;