<%-- Copyright 2000 SAS Institute Inc, Atlanta, GA, 30326 --%>

<%@page import="java.io.*, java.util.*" %>
<%@page import="com.sas.hrv.*" %>
<%@ include file="../Jsp/forwardURL.jsp" %>

<%
	// This jsp actually attempts to log in to HRVInfo.  If it is successful, it forwards
	// to the target jsp (either the user's preferred initial page or the jsp they were
	// after at the time the login was triggerred).  If the login is unsuccessful, the
	// user is redirected back to loginF.jsp (and, in turn, login.jsp).

	// modified 6JUN01 by TGL to set the cookies regardless of a successful login

	HrvInfo   hrvi       = HrvInfo.getInstance(application, request, response, out);
	VisMsg    vM         = VisMsg.getInstance(session);
	String    url        = vM.getLink("LoginHome");
	CodeBean cB = new CodeBean(session);
	boolean force = false;
	if (url == null) url = "../Jsp/login.jsp";
	url                  = new String(url + "?FAILED=Y");
   	String    errStr     = null;
	String action = request.getParameter("ACTION");
	String forgot = request.getParameter("FORGOT");
	String user   = request.getParameter("USERID");


	// Make sure the userid gets lowercased before we consume it (S0222566)

	if (user != null)
		user = user.toLowerCase();

	String curWH  = request.getParameter("WHOUSE");
	String mainLogin;
	String userMainLogin;
	final int month  = 60 * 60 * 24 * 30;

try {
	if (forgot != null && forgot.equals("Y")) {
		try {
			// user is requesting that their password be mailed to them,
			// set the user cookie.
			Cookie uidCookie = new Cookie("com.sas.hrv.lastuser",user);
			uidCookie.setMaxAge(month);
			response.addCookie(uidCookie);

			// set the warehouse cookie.
			curWH = curWH.trim();
			Cookie whCookie  = new Cookie("com.sas.hrv.warehouse",curWH);
			whCookie.setMaxAge(month);
			response.addCookie(whCookie);

			// send the user their password that they forgot.
			UserBean ub = new UserBean(session);
			errStr = ub.forgotPW(user, curWH, false);
			throw new Throwable();
		}
		catch (javax.mail.MessagingException e) {
			// this exception is really due to the mail server not being set correctly (invalid server).
			// We have the same message as the general exception for now, but in the future we can add
			// a message (Fmessage9.txt) to this effect.
			errStr = "&msg=" + vM.getLabel("Fmessage7.txt");
			throw new Throwable();
		}
		catch (Exception e) {
			errStr = "&msg=" + vM.getLabel("Fmessage7.txt");
			throw new Throwable();
		}
   }

	// there must be an action of LOGIN
	if (action == null || !action.equals("LOGIN")) {
		errStr = "&msg=" + vM.getSentence("loginActionField") + " ";
		throw new Throwable();
	}

	// get the passed in parameters
	String pw     = request.getParameter("PASSWORD");
	if (pw == null)
		pw = "";
	String specPw = (String) session.getAttribute("specPw");
	session.removeAttribute("specPw");
	if (specPw == null)
		specPw = "";

	// check the warehouse and set the cookie
	if (curWH == null || curWH.trim().equals("")) {
		errStr = "&msg=" + vM.getSentence("LoginWarehouse2Error") + "&errorType=wh";
		throw new Throwable();
	}
	else {
		curWH = curWH.trim();
		Cookie whCookie  = new Cookie("com.sas.hrv.warehouse",curWH);
		whCookie.setMaxAge(month);
		response.addCookie(whCookie);
	}

	// check the user and set its cookie
	if (user == null || user.trim().equals("") || user.trim().equals("null")) {
		errStr = "&msg=" + vM.getSentence("LoginUsernameError") + " ";
		throw new Throwable();
   }
   else {
   	user = user.trim();
		Cookie uidCookie = new Cookie("com.sas.hrv.lastuser",user);
		uidCookie.setMaxAge(month);
		response.addCookie(uidCookie);
   	try {
			cB.setWarehouseKey(curWH);
   			cB.setUser(user);
		}
		catch (InvalidRepositoryException e) {
			// blank out the warehouse value in the cookie.
			Cookie whCookie  = new Cookie("com.sas.hrv.warehouse","");
			whCookie.setMaxAge(month);
			response.addCookie(whCookie);
			// report the error.
			errStr = "&msg=" + vM.getSentence("LoginWarehouse2Error") + "&errorType=wh";
			throw new Throwable();
		}
	   catch (Exception e) {
			errStr = "&msg=" + vM.getSentence("LoginBadUsernameError") + " ";
			throw new Throwable();
	   }
  	}

  	// check the password
	if ((pw == null || pw.trim().equals("")) && !specPw.equals("skipIt")) {
		errStr = "&msg=" + vM.getSentence("LoginPasswordError") + " ";
		throw new Throwable();
	}
	else {
		pw = pw.trim();
   }

	// log the user off of another session if necessary.
	String confirmForce = request.getParameter("confirmForce");
	if (confirmForce == null)
		confirmForce = "";
	String confirmForceUser = request.getParameter("confirmForceUser");
	if (confirmForceUser == null)
		confirmForceUser = "";
	if (!confirmForceUser.equals(user))
		confirmForce = "n";
	session.setAttribute("confirmForce", confirmForce);

	// --- perform the login attempt ---
	errStr        = "&msg=" + vM.getSentence("LoginInvalidError") +" ";
	try {
		if (specPw.equals("skipIt")) {
			hrvi.fakeLogIn(session, user, curWH);
	   	hrvi.setUserValue(session, "showExitScreen", "Yes");
		}
		else {
			hrvi.logIn(session, curWH, user, pw, request);
		}
	}
	catch (UserAlreadyLoggedInException e) {
   		// user is already logged in under a different session.  Force that
   		// session off and proceed with the login.
		errStr = "&msg=" + vM.getLabel("Error") + ": " + user + " " + vM.getSentence("AlreadyLoggedIn") + " &confirmForce=yes&confirmForceUser=" + user;
         	throw new Throwable();
	}

	if (!hrvi.isLoggedIn(user))
        	throw new Throwable();




	// --- get the entry point into the system for this user
	mainLogin = "../Jsp/HRVision.jsp";  // default
	userMainLogin = (String)HrvInfo.getSessionValue(session, "UserHome");;  // users default
	errStr       = null;
	url          = mainLogin;
	String eURL  = userMainLogin;

	if (eURL == null)
		eURL = request.getParameter("RETURNURL");
	if (eURL != null){
		// returnurl is set, so that's where they should go upon logging in.

		// clean up url for netscape.
		if(eURL.startsWith("'"))
			eURL = eURL.substring(1);
		else if(eURL.startsWith("%27"))
			eURL = eURL.substring(3);

		int p = eURL.indexOf("&HRVRETURNURLTERM");
		if (p >= 0)
			eURL = eURL.substring(0, p);
        	url = eURL;
	}
	else if ((eURL = vM.getLink("MainHome")) != null)
        	url = eURL;


	// log the initial window into HrvInfo if it is one of the default initial windows and not
	// an "external" window.
	int p;
	String testStr = "";
	String userTestStr = "";
	if (mainLogin != null) {
		p = mainLogin.lastIndexOf("/");
		if (p >= 0)
			testStr = mainLogin.substring(p+1);
	}
	if (userMainLogin != null) {
		p = userMainLogin.lastIndexOf("/");
		if (p >= 0)
			userTestStr = userMainLogin.substring(p+1);
	}

	// Add in the initial windowId if not already present (S0262210)
	Vector winList = hrvi.getUsedWindowIds(session);
	if (winList == null || ((winList != null) && !winList.contains(hrvi.returnMainWindowId())))
		hrvi.addInitialWindowId(session);

	}
   catch (Throwable e) {
   	// login failed, so make sure to propagate returnUrl....
		String returnUrl = request.getParameter("RETURNURL");
		if (returnUrl != null) {
			if (url.indexOf("?") < 0)
				url = url + "?";
			else
				url = url + "&";
			url = url + "RETURNURL='" + returnUrl + "'";
		}
	}
	if (errStr != null)
		url = new String(url + errStr);

	//////Matt's Stuff
	//check and see if this is the users first login with this password...
	String firstTimeParm = "";
	try{
		firstTimeParm = cB.getUserAttributeValue("newPass");
	}catch(Exception e){
		firstTimeParm = "NO";
	}

	if((firstTimeParm != null && firstTimeParm.equalsIgnoreCase("YES")) && !cB.isAdmin()){
		String firstTime = "../Jsp/loginPwdChange.jsp";
		session.setAttribute("URL", url);

		if(errStr == null || errStr.equals(""))
			forwardURL(firstTime,out,request,response);
		else
			forwardURL(url,out,request,response);
		return;
	}
	///////End of Matt's Stuff

	// --- Now forward this request to either login, or, the main entry point ---

	forwardURL(url,out,request,response);
 %>