<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     propertiesItem.jsp
// AUTHOR:   cahadd - Casey Hadden
// SUPPORT:  cahadd - Casey Hadden
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  clearing house for properties screen... prevent in
//           place editing
//
// HISTORY:   Date    Who  Action
//           -------------------------------------------------------
//           26JUN01  jch  initially created
/*********************************************************************/
%>
<%@ include file="HRVLoginInclude.jsp"%>

<%!
    final String TABLE = "TABLE";
    final String QUERY = "QUERY";
    final String MDDB = "MDDB";
    final String ANALYSIS = "ANALYSIS";
    final String KPI = "KPI";
    final String REPORT = "REPORT";
    final String REPORTEDIT = "REPORTEDIT";

    final String EXPLORER_TABLE = "tables";
    final String EXPLORER_REPORT = "reports";
    final String EXPLORER_ANALYSIS = "analyses";
    
    final String RESET_COMMAND = "RESET";
    final String COPY_COMMAND = "COPY";
    final String SAVE_COMMAND = "SAVE";
    final String CANCEL_COMMAND = "CANCEL";
    final String EDIT_COMMAND = "EDIT";

    // function to close the window out
    void closeWindow (HttpSession session, JspWriter out, String window, String type, ItemBean currentItem) 
        throws Exception { 
        
        // get the topic from what they've set on this item
        Vector topicList = currentItem.getSubjects ();
        // use the first topic
        String topic = null;
        try {
            topic = (String)topicList.get (0);
            TopicBean tB = new TopicBean (session);
            tB.setMetaLocation (MetaBean.PUBLIC_LOC);
            tB.setMetaKey (topic);

            // this should throw an exception if the topic doesn't exist.           
            String desc = tB.getAttributeValue ("desc");
            
        } catch (Exception e) {
            topic = null;
        }
        // if there wasn't a topic then default us back to all
        if (topic == null || topic.equals (""))
            topic = "all";
        
        // window is now always mainHRVWindow
        window = HrvInfo.returnMainWindowId ();

        // use the bean to get the type
        type = currentItem.getMetaTag ();
        
        // if it's a table, it really might be an mddb check that out
        if (type.equalsIgnoreCase (TABLE)) {
            String tbltype = currentItem.getAttributeValue ("tbltype");
            if (tbltype == null)
                tbltype = "";
            // if the tabletype says it's an mddb, then make it so.
            if (tbltype.equalsIgnoreCase ("MDDB"))
                type = MDDB;
        }
        
        if (type != null) {
            if (type.equalsIgnoreCase (TABLE) || type.equalsIgnoreCase (QUERY)) {
                type = EXPLORER_TABLE;
            } else if (type.equalsIgnoreCase (ANALYSIS) || 
                       type.equalsIgnoreCase (KPI) || 
                       type.equalsIgnoreCase (MDDB)) {
                type = EXPLORER_ANALYSIS;
            } else if (type.equalsIgnoreCase (REPORT)) {
                type = EXPLORER_REPORT;
            } else {
                // default to tables
                type = EXPLORER_TABLE;
            }
        } else {
            type = EXPLORER_TABLE;
        }

        // determine our action upon close of the window
        OptionBean options = OptionBean.getInstance (session);
        String use_aux = options.getOption ("use_aux");
        out.println ("<script language=\"javascript\">");
        if (use_aux.equalsIgnoreCase ("yes")) {
            out.println ("var HrvScratchWindowClose = open('../Jsp/closeWindow.jsp?winName=' + parent.name, 'HrvScratchWindowClose', 'height=1 width=1');");
            if (((String)HrvInfo.getBrowserType (session)).equalsIgnoreCase ("IE")) {
                out.println ("var explorer = open ('../Jsp/explorer.jsp?topic=" + topic + "&type=" + type + "','" + window + "','');");
            }
            out.println ("self.close ();");
        } else {
            out.println ("top.location='../Jsp/explorer.jsp?type=" + type + "&topic=" + topic + "';");
        }   
        out.println ("</script>");
    }
%>

<%
    final String [][] ITEM_TYPES = { { "TABLE", "TABLES" }, { "MDDB", "ANALYSES" },
                                   { "ANALYSIS", "ANALYSES" }, { "KPI", "ANALYSES" },
                                   { "REPORT", "REPORTS" } };

    // parameters we're interested in.
    String location = request.getParameter ("location");
    String key = request.getParameter ("key");
    String properKey = request.getParameter ("properKey");
    String command = request.getParameter ("command");
    String explorerType = request.getParameter ("explorerType");
//System.out.println ("explorerType: " + explorerType); 
    String itemType = request.getParameter ("actualType");
//System.out.println ("itemType: " + itemType); 
    String saveString = request.getParameter ("saveString");

    // check ones that could be null
    if (saveString == null) {
        saveString = "SAVE";
        // only useful in one case.
    }
    if (itemType == null) {
        itemType = request.getParameter ("type");
    }

    String topic = request.getParameter ("topic");
    String window = request.getParameter ("window");

    ItemBean currentItem = null;
    String forwardUrl = null;
    VisMsg vM = VisMsg.getInstance (session);
    
    boolean isAdmin = HrvInfo.isUserAdmin (session);
    if (location == null) {
        if (isAdmin) {
            location = MetaBean.PUBLIC_LOC_STRING;
        } else {
            location = MetaBean.PRIVATE_LOC_STRING;
        }
    }

    // if no command, then we are entering from explorer
    String returnType;
    String keyString = "key";
    if (command == null) {
        // create bean and copy value to temp
        if (itemType.equalsIgnoreCase (TABLE)) {
            currentItem = new TableBean (session);
            returnType = "tables";
        } else if (itemType.equalsIgnoreCase (MDDB)) {
            currentItem = new TableBean (session);
            returnType = "analyses";
        } else if (itemType.equalsIgnoreCase (ANALYSIS)) {
            currentItem = new AnalysisBean (session);
            returnType = "analyses";
        } else if (itemType.equalsIgnoreCase (KPI)) {
            currentItem = new KPIBean (session);
            returnType = "analyses";
        } else if (itemType.equalsIgnoreCase (REPORT)) {
            currentItem = new ReportBean (session);
            returnType = "reports";
        } else if (itemType.equalsIgnoreCase (REPORTEDIT)) {
            currentItem = new ReportBean (session);
            returnType = "reports";
            keyString = "REPORT";
        } else if (itemType.equalsIgnoreCase (QUERY)) {
            currentItem = new TableBean (session);
            returnType = "tables";
        } else {
            currentItem = new ItemBean (session);
            returnType = "tables";
        }
    
        currentItem.setMetaLocation (Integer.parseInt (location));
        // move it to the temp directory
        currentItem.setMetaKey (key);

        if (itemType.equalsIgnoreCase (QUERY)) {
            currentItem.setAttributeValue ("subject", topic);
            itemType = TABLE;
        }

        // only copy if item is private, or if public and user is sysadm
        String newKey = key;
        if ( (location.equals (currentItem.PUBLIC_LOC_STRING) && isAdmin) ||
             location.equals (currentItem.PRIVATE_LOC_STRING)) {
            newKey = currentItem.copyItemToTemp (Integer.parseInt ( location));
            currentItem.setTemp (true);
            // write a copy to temp
            currentItem.setMetaKey (newKey);
        }
    
        // put the object on the session
        session.setAttribute (newKey, currentItem);

        // get the correct url to forward to
        String ourUrl = itemType.toUpperCase () + "_PROPSmain";
        forwardUrl = vM.getLink (ourUrl);

        // now add the information we'll need   
        forwardUrl += "?" + keyString + "=" + newKey + "&location=" + location + "&saveString=" + saveString;

        // persist the window/topic/type attributes
        forwardUrl += "&topic=" + topic + "&window=" + window + "&explorerType=" + returnType + "&actualType=" + itemType;

        // always add what item we're changing in the end
        forwardUrl += "&properKey=" + key;

        // if editing a report tell the reportbuilder that it's already in temp
        if (itemType.equalsIgnoreCase (REPORTEDIT)) {
            forwardUrl += "&EDIT=yes";
        }

        if (itemType.equalsIgnoreCase (TABLE)) {

            TableBean properItem = new TableBean (session);
            properItem.setMetaLocation (Integer.parseInt (location));
            properItem.setMetaKey (key);

            session.setAttribute (key, properItem);
        }

        forwardURL (forwardUrl, out, request, response);

    } else if (command.indexOf (SAVE_COMMAND) >= 0) {
    // we are saving the item
        GenericPropertyBean thisProps = (GenericPropertyBean)HrvInfo.getSessionValue (session, key);

        // see if we're coming from the prompter
        String fromPrompt = request.getParameter ("fromprompt");
        if (fromPrompt == null)
            fromPrompt = "n";
            
        // save now takes care of all the new key stuff
        if (!fromPrompt.equalsIgnoreCase ("Y"))
            thisProps.save (request);   

        currentItem = (ItemBean)session.getAttribute (key);
        
        String wasCopy = (String)HrvInfo.getSessionValue (session, COPY_COMMAND + "_" + properKey);
        if (wasCopy != null) {
            try {
                if (itemType.equalsIgnoreCase (TABLE) && !fromPrompt.equalsIgnoreCase ("Y")) {
                
                    if (((TableBean)currentItem).getUserPrompts ().size () > 0) {
                
                        String sendtourl = "../Jsp/userPrompt.jsp?command=RUN&key=" + currentItem.getMetaKey ();                

                        String returnURL = "../Jsp/propertiesItem.jsp?command=" + command + "&actualType=" + itemType + "&explorerType=" + explorerType + "&location=" + location + "&key=" + key + "&properKey=" + properKey + "&saveString=" + saveString + "&fromprompt=y";
                    
                        session.setAttribute ("returnURL", returnURL);

                        forwardURL (sendtourl, out, request, response);
                        return;
                    }
                }
            
                currentItem.refreshItem ();
            } catch (Exception e) {
                // catch any exceptions and put them in the java log
                e.printStackTrace ();
            }
            
            HrvInfo.removeSessionValue (session, COPY_COMMAND + "_" + properKey);
        }

        // get the item type...
        String type = currentItem.getMetaTag ();
        // if we have a table then check out the propagation stuff...
        if (type.equalsIgnoreCase (TABLE)) {
            String propagationIndicator = request.getParameter ("columnpropagateindicator");
            if (propagationIndicator != null &&     
                propagationIndicator.equalsIgnoreCase ("Y")) {
                // if it's yes, then we have something to propagate.
                // generate a nested named list containing the various fields that we set.
                NamedList perpCols = new NamedList();
                
                
                String column = request.getParameter ("propagatecolumn");
                String attr = request.getParameter ("propagatecolumnattr");
                String val = request.getParameter ("propagatecolumnval");
                
                // now we need to parse the various strings, start by 
                // taking the first character off, it's always a *
                column = column.substring (1);
                attr = attr.substring (1);
                val = val.substring (1);
                
                // get the index of the asterisks
                String delim = "\u00B6";
                int columnStarIndex = column.indexOf (delim);
                int attrStarIndex = attr.indexOf (delim);
                int valStarIndex = val.indexOf (delim);
                
                // if there is still an asterisk in the column variable, then
                // all the fields should have more items
                while (columnStarIndex >= 0) {
                    NamedList perpAttrs = new NamedList(true);
                    String thisColumn = column.substring (0, columnStarIndex);
                    String thisAttr = attr.substring (0, attrStarIndex);
                    String thisVal = val.substring (0, valStarIndex);
                    
                    // load up the named lists.
                    perpAttrs.add(thisAttr, thisVal);
                    perpCols.add(thisColumn, perpAttrs);
                    
                    // get rid of these items on the strings
                    column = column.substring (columnStarIndex+1);
                    attr = attr.substring (attrStarIndex+1);
                    val = val.substring (valStarIndex+1);
                    
                    // now get the next asterisk positions
                    columnStarIndex = column.indexOf (delim);
                    attrStarIndex = attr.indexOf (delim);
                    valStarIndex = val.indexOf (delim);
                }
                session.setAttribute("perpAttrs_" + properKey, perpCols);
                forwardUrl = "../Jsp/perpetuateProperties.jsp?key=" + properKey + "&location=" + location;
                forwardURL (forwardUrl, out, request, response);
                return;
            }
        }

        closeWindow (session, out, window, explorerType, currentItem);
    } else if (command.equalsIgnoreCase (CANCEL_COMMAND)) {
    // canceling the item.
        currentItem = (ItemBean)session.getAttribute (key);
        if ( (location.equals (currentItem.PUBLIC_LOC_STRING) && isAdmin) ||
             location.equals (currentItem.PRIVATE_LOC_STRING)) {
            currentItem.removeItem ();
        
            if (properKey != null && !properKey.equalsIgnoreCase (key) &&
                saveString.indexOf ("NEW") >= 0 && 
                explorerType.equalsIgnoreCase ("TABLES")) {
                
                currentItem = (ItemBean)session.getAttribute (properKey);
                currentItem.removeItem ();
            }
        }

        closeWindow (session, out, window, explorerType, currentItem);
    } else if (command.equalsIgnoreCase (RESET_COMMAND)) {
        // if we have created a temp item then remove it
        if ((location.equals (currentItem.PUBLIC_LOC_STRING) && isAdmin) ||
             location.equals (currentItem.PRIVATE_LOC_STRING)) {
             currentItem = (ItemBean)session.getAttribute (key);
             currentItem.removeItem ();
        }
        
        // now forward back to this page just as if we're coming from explorer
        forwardUrl = "../Jsp/propertiesItem.jsp?key=" + properKey + "&location=" + location + "&window=" + window + "&topic=" + topic + "&type=" + itemType;
        forwardURL (forwardUrl, out, request, response);
    } else if (command.equalsIgnoreCase (COPY_COMMAND)) {
        // get the currentitem
        currentItem = (ItemBean)session.getAttribute (key);

        // get the current description to modify it later
        String currentDesc = currentItem.getAttributeValue ("desc");

        //determine where to copy it to
        int locationInt = ItemBean.PRIVATE_LOC;
        if (isAdmin) {
            locationInt = ItemBean.PUBLIC_LOC;
        }
        
        // copy the item from temp back to the regular area
        String newKey = currentItem.copyItem (locationInt);

        // if we could have created/edited this item
        if ((location.equals (currentItem.PUBLIC_LOC_STRING) && isAdmin) ||
             location.equals (currentItem.PRIVATE_LOC_STRING)) {
            // remove the temporary item
            currentItem.removeItem ();
            // we aren't in temp anymore
            currentItem.setTemp (false);
        }
        
        // set the currentItem to the copy we just made     
        currentItem.setMetaKey (newKey);
        currentItem.setMetaLocation (locationInt);
        
        // change the description
        currentItem.setAttributeValue ("desc", vM.getLabel ("Copyof") + " " + currentDesc);
        
        // if a table, then change the key's in sassource attribute
        if (itemType.equalsIgnoreCase (TABLE)) {
            String currentSource = currentItem.getAttributeValue ("sassource");
            
            // fix the sassource entry
            if (currentSource != null) {        
                StringBuffer newSource = new StringBuffer (currentSource);
                int properKeyIndex = newSource.toString().indexOf (properKey);
                while (properKeyIndex >= 0) {
                    newSource.replace (properKeyIndex, properKeyIndex + properKey.length (), newKey);
                    properKeyIndex = newSource.toString().indexOf (properKey);
                }   

                currentItem.setAttributeValue ("sassource", newSource.toString());
            }
            
            // add datasetname entry if needed
            String datasetname = currentItem.getAttributeValue ("datasetname");
            
            if (datasetname == null ||
                (datasetname != null && datasetname.equals (""))) {
                currentItem.setAttributeValue ("datasetname", properKey);
            }
            
            // check for userprompts if it's a public table we're copying and we're 
            // a private user
/*          if (location.equals (MetaBean.PUBLIC_LOC_STRING) &&
                !HrvInfo.isUserAdmin (session)) {
                
                // check to see if we have any userprompts
                NamedList userPrompts = ((TableBean)currentItem).getUserPrompts ();
                NamedList newPromptList = new NamedList ();
                if (userPrompts.size () > 0) {
                    for (int i = 0; i < userPrompts.size (); i++) {
                        String currentPrompt = (String)userPrompts.getValue (i);
                        
                        UserPromptBean up = new UserPromptBean (session);
                        up.setMetaKey (currentPrompt);
                        // if we're doing this it's always public loc
                        up.setMetaLocation (MetaBean.PUBLIC_LOC);

                        // now copy the prompt to private location
                        String newPromptKey = up.copyItem (MetaBean.PRIVATE_LOC);

                        // add the properties back                      
                        NamedList thisPromptList = new NamedList ();
                        thisPromptList.add ("column", 
                            currentItem.getMetaSubListAttribute 
                            ("userprompts", currentPrompt, "column"));
                        thisPromptList.add ("oper", 
                            currentItem.getMetaSubListAttribute 
                            ("userprompts", currentPrompt, "oper"));

                        newPromptList.add (newPromptKey, thisPromptList);

                        // replace the prompt in sassource and qrysrc
                        String sassource = currentItem.getAttributeValue ("sassource");
                        StringBuffer newSASSource = new StringBuffer (sassource);
                        int keyIndex = newSASSource.toString().indexOf (currentPrompt);
                        while (keyIndex >= 0) {
                            newSASSource.replace (keyIndex, keyIndex + currentPrompt.length (), newPromptKey);
                            keyIndex = newSASSource.toString().indexOf (currentPrompt);
                        }   

                        currentItem.setAttributeValue ("sassource", newSASSource.toString());

                        String qrysrc = currentItem.getAttributeValue ("querysrc");
                        StringBuffer newQuerySource = new StringBuffer (qrysrc);
                        keyIndex = newQuerySource.toString().indexOf (currentPrompt);
                        while (keyIndex >= 0) {
                            newQuerySource.replace (keyIndex, keyIndex + currentPrompt.length (), newPromptKey);
                            keyIndex = newQuerySource.toString().indexOf (currentPrompt);
                        }   

                        currentItem.setAttributeValue ("querysrc", newQuerySource.toString());
                    }
                    
                    ((TableBean)currentItem).setUserPrompts (newPromptList);
System.out.println ("newPromptList: " + newPromptList); 

                }
            }*/
            
        } else if (itemType.equalsIgnoreCase (MDDB)) {
            String datasetname = currentItem.getAttributeValue ("datasetname");
            
            // if datasetname is blank or missing, then the old table name was
            // the key... set this items dataset name to be the key
            if (datasetname == null || 
                (datasetname != null && datasetname.equals (""))) {
                currentItem.setAttributeValue ("datasetname", properKey);
            }
        } else if (itemType.equalsIgnoreCase (REPORT)) {
            // blank out the rundate for reports so that Ron will rerun them
            // upon opening.
            currentItem.setAttributeValue ("rundate", "");
        }
        
        // write out the changes
        currentItem.write ();

        HrvInfo.setSessionValue (session, COPY_COMMAND + "_" + currentItem.getMetaKey (), "copied");
        
        // forward us back to the propertiesItem with this new information
        // everything else should be taken care of
        forwardUrl = "../Jsp/propertiesItem.jsp?key=" + newKey + "&location=" + locationInt + "&window=" + window + "&topic=" + topic + "&type=" + itemType;
        
        forwardURL (forwardUrl, out, request, response);
    } else if (command.equalsIgnoreCase (EDIT_COMMAND)) {
        GenericPropertyBean thisProps = (GenericPropertyBean)HrvInfo.getSessionValue (session, key);
        // save now takes care of all the new key stuff
        thisProps.save (request);   

        forwardUrl = vM.getLink (itemType.toUpperCase () + "_" + command.toUpperCase ());

        if (itemType.equalsIgnoreCase (REPORT) || itemType.equalsIgnoreCase (EXPLORER_REPORT)) {
            forwardUrl += "?REPORT=" + key + "&saveString=" + saveString;
        } else {
            forwardUrl += "?key=" + key;
//          Brian now has the temp stuff set up, so use that.
//          forwardUrl += "?key=" + properKey;
        }

        // always put properKey on...
        forwardUrl += "&properKey=" + properKey;
        
        forwardUrl += "&location=" + location + "&type=" + itemType + "&topic=" + topic + "&window=" + window + "&saveString=" + saveString + "&fromProps=Y" + "&explorerType=" + explorerType + "&actualType=" + itemType;;
        
        forwardURL (forwardUrl, out, request, response);
    }
%>