<%@page import="java.io.*,java.util.*,java.lang.Object" %> 
<%@page import="com.sas.hrv.*" %>
<%@page import="com.sas.net.server.RemoteSasException" %>
<%@page import="java.net.URLEncoder" %>
<%@include file="HRVLoginInclude.jsp"%>

<%	
	/*********************************************************************/
	// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
	/*********************************************************************/
	//
	// NAME:     tableViewer.jsp
	// AUTHOR:   sasjs1 - Jeff Schrilla
	// SUPPORT:  sasjs1 - Jeff Schrilla
	// PRODUCT:  hrvision
	// TYPE:     jsp page
	// LANGUAGE: java
	// PURPOSE:  Display a SAS table.
	//
	//	required parameters:
	//		key - the key of the table to display.
	//		
	// allowed parameters:
	//		notitle - true/false, turns the title off/on.
	//		style - overrides the default (primary) style on the body tag.
	//		nolink - true/false, disables/enables link var setup (generally emp. ID).
	// 	subset - a valid SAS where clause to subset the data with (use single
	//					quotes if quotes are necessary).
	// 	subsetKey - a valid subset key to apply to the table.
	// 	subsetLoc - the location of the subset key to apply to the table.
	// 	ctrlButtons - true/false, enables/disables the control buttons for subsetting
	//							etc.
	//		colHighlt - the column name (not label) that should be highlighted (if any).
	// 	CURRENTVIEW - a view name you wish to force the table to use or reuse.
	// 	currentLibname - the libname that you want the view in.
	// 	refresh - force a refresh of the table/view on the TableCtrl object.  This
	//					 is very useful when you want to display a "new" table with the
	// 				 same name as an old table.  Set to "y" for a refresh.
	// HISTORY:   Date    Who     Action	
	// S0262694  01Aug04  sby     added onUnload() so that IE X to work in tableviewer	
	/*********************************************************************/

	// get the message system.
	VisMsg vM = VisMsg.getInstance(session);

	// set this url on hrvi for further use.
	String params = request.getQueryString();
	String uri = request.getRequestURI();
	String myUrl;
	if (params != null && !params.equals(""))
		myUrl = uri + "?" + params;
	else
		myUrl = uri;
	hrvi.setSessionValue(session, "tableViewerUrl", myUrl);		

	// get the clear command value.
	String clear = request.getParameter("clear");
	if (clear == null)
		clear = "";

	String viewOnly=request.getParameter("viewOnly");
	if (viewOnly == null)
		viewOnly = "";
	String hideWhere=request.getParameter("hideWhere");
	if (hideWhere == null)
		hideWhere = "";
	
	// get special views coming from user-prompted queries
	
	
	//String queryPromptView = request.getParameter("queryPromptView");
	//if (queryPromptView==null) queryPromptView="";
	
	// set constants (arrows)....
	String DBLLEFT = "../Images/double_left_01g.gif";
	String LEFT = "../Images/left_01g.gif";
	String RIGHT = "../Images/right_01g.gif";
	String DBLRIGHT = "../Images/double_right_01g.gif";

	// Pull variables from the url.
	// get the table name.
	String tableNameParameter = request.getParameter("key");
	if (tableNameParameter != null && tableNameParameter.equalsIgnoreCase("null"))
		tableNameParameter = null;

	String noTitle = request.getParameter("notitle");
	String style = request.getParameter("style");
	
	// Disable the link variable (which is always employee profile) if the user is forbidden from viewing the 
	// employee profile.  Otherwise, read in the parameter to this jsp as usual.
	UserBean uB = new UserBean(session);
	String ep = uB.getAttributeValue("empprofile");
	String noLink;
	if (ep == null || "yes".equalsIgnoreCase(ep) || "".equals(ep))
		noLink = request.getParameter("nolink");
	else noLink = "true";
	
	String subsetKey = request.getParameter("subsetKey");
	String subsetLoc = request.getParameter("subsetLoc");
	
	if (subsetLoc == null)
		subsetLoc = ItemBean.PUBLIC_LOC_STRING;
	String subsetParameter = request.getParameter("SUBSET");
	if (subsetParameter == null)
		subsetParameter = request.getParameter("subset");

	// pass on the subset (a straight where clause) if it's available.
	String passOnSubset = "";
	if (subsetParameter != null && !subsetParameter.equals(""))
		passOnSubset = "&subset=" + URLEncoder.encode(subsetParameter);
	
	String ctrlButtons = request.getParameter("ctrlButtons");
	if (ctrlButtons == null)
		ctrlButtons = "true";
	String radioButtons = request.getParameter("radioButtons");
	if (radioButtons == null)
		radioButtons = "false";
	String colHighlt = request.getParameter("colHighlt");
	String refresh = request.getParameter("refresh");
	if (refresh == null)
		refresh = "";
	String jumpToRow = request.getParameter("jumpToRow");
	if (jumpToRow == null)
		jumpToRow = "";
		
	// set the style and title for the table based on passed in params.
	if (style == null || style.equals(""))
		style = "bodyContents";
	
	// special parameter used by Employee Profile
	String eep = request.getParameter( "eep" );
	if( eep == null )
		eep = "false";

	// determine the libname (public or private).
	String libNameParameter = ItemBean.PUBLIC_DATA_LIBREF;
	String location = request.getParameter("location");
	if (location != null) {
		if (location.equalsIgnoreCase(ItemBean.PRIVATE_LOC_STRING) || location.equalsIgnoreCase("Private") || location.equalsIgnoreCase(ItemBean.PRIVATE_DATA_LIBREF)) {
			libNameParameter = ItemBean.PRIVATE_DATA_LIBREF;
			location = ItemBean.PRIVATE_LOC_STRING;
		}
		else if (location.equalsIgnoreCase(ItemBean.PUBLIC_LOC_STRING) || location.equalsIgnoreCase("Public") || location.equalsIgnoreCase(ItemBean.PUBLIC_DATA_LIBREF)) {
			libNameParameter = ItemBean.PUBLIC_DATA_LIBREF;
			location = ItemBean.PUBLIC_LOC_STRING;
		}
	}
		
	String currentView = request.getParameter("CURRENTVIEW");
	if (currentView == null)
		currentView = request.getParameter("currentView");
	String currentLibname = request.getParameter("currentLibname");
	if (currentLibname == null)
		currentLibname = "work";
		
	// generate the string that we want to look up the table with.
	String tempView = "";
	if (currentView != null) {
		tempView = currentView;
		if (currentView.indexOf(".") < 0)
			tempView = currentLibname + "." + currentView;
	}
	
	// set up the number of rows to display....
	OptionBean opt = OptionBean.getInstance(session);
	String num;
	if (eep.equalsIgnoreCase("true")) {
		// this is displaying a table for the employee profile, so use the appropriate option.
		num = opt.getOption("eep_rows");
	}
	else {
		num = opt.getOption("table_rows");
	}
	int rows = 10;
	if (num != null)
		if (!num.equals(""))
			rows = Integer.parseInt(num);
	
	// now, set up the TableCtrl object.
	TableCtrl hrvTable;
	if (currentView == null) 
		hrvTable = null;
	else
		hrvTable = (TableCtrl) hrvi.getSessionValue(session, "TABLE_" + tempView);
	if (hrvTable == null || refresh.equalsIgnoreCase("Y")) {
		try {
			if (tableNameParameter != null) {
				// instantiate our table bean and set it up.
				hrvTable = new TableCtrl(session, location, tableNameParameter);
				// since you have the table key, assume the view needs to be made and
				// create a view/data set using the MakeView object.
				MakeView hrvMakeView = hrvTable.getMakeView();
				
				
				
				if (!hrvTable.getPromptTableView().equals("")){
					//currentView = queryPromptView;
					currentView = hrvTable.getPromptTableView();
				}
				else {
					hrvMakeView.setOutputType("view");
					if (currentView != null && !currentView.equals("")) {
						// we have a view name to use.  Make sure that libname. is not prepended to it.
						int p = 	currentView.indexOf(".");
						while ( p > 0) {
							currentView = currentView.substring(p+1);
							p = currentView.indexOf(".");
						}
						hrvMakeView.setOutputName(currentView);
					}
				}
				String dwup = request.getParameter("doneWithUP");
								
				if (dwup == null) {
					dwup = (String) session.getAttribute("doneWithUP");
					if (dwup != null)
						session.removeAttribute("doneWithUP");
				}
				if (dwup != null && dwup.equalsIgnoreCase("Y"))
					libNameParameter = "DWDATA";
				try {
					if (hrvTable.getPromptTableView().equals("") ||
													dwup == null || 
						opt.getOption("promptuser").equalsIgnoreCase("n")){
							currentView = hrvMakeView.create(tableNameParameter, libNameParameter, false, "", Integer.parseInt(location), false);
					}
					else if	 (!hrvTable.getPromptTableView().equals(""))
					{
						String workTab = hrvTable.getPromptTableView().substring(hrvTable.getPromptTableView().indexOf(".")+1);						
						currentView = hrvMakeView.create(tableNameParameter, libNameParameter, false, "", Integer.parseInt(location), false, workTab);
					}
				}
				catch (Exception e) {
					out.println( "<HTML><HEAD>" );
					out.println( "</head>" );
					out.println( "<body class=\"bodyContents\">" );
					out.println( "<table width=\"100%\" height=\"100%\" cellspacing=\"20\">" );
					out.println( "<tr><td align=\"center\">"+vM.getLabel("tableNotFound")+"</td></tr>" );
					out.println( "</table></body></html>" );
					return;
				}
			}
			else {
				// assume the view/data set exists already since we don't have the key.
				hrvTable = new TableCtrl(session);
			}
				
			hrvi.setSessionValue(session, "table_" + currentView, (Object) hrvTable);

			hrvTable.setMaxRows(rows);
			// set the data set/view on the table bean.
			hrvTable.setView(currentView);
			// set vars to be passed along.
			hrvTable.setPerpetuateVar("CURRENTVIEW");
			hrvTable.setPerpetuateVar("style");
			hrvTable.setPerpetuateVar("ctrlButtons");
			hrvTable.setPerpetuateVar("viewOnly");
			hrvTable.setPerpetuateVar("hideWhere");
			hrvTable.setPerpetuateVar("key");
			hrvTable.setPerpetuateVar("location");
			// set up the link variable.
			if (noLink == null || !noLink.equals("true"))
				hrvTable.setLink("ID", "empprofile.jsp", "empprofile");

			String forwardUrl = "tableViewer.jsp?CURRENTVIEW=" + currentView + "&key=" + tableNameParameter + "&location=" + libNameParameter + "&style=" + style + "&nolink=" + noLink + "&notitle=" + noTitle + "&ctrlButtons=" + ctrlButtons + "&radioButtons=" + radioButtons + "&colHighlt=" + colHighlt + "&viewOnly=" + viewOnly + "&hideWhere=" + hideWhere + passOnSubset + "&eep=" + eep;

			// keep parameter (which columns are displayed).
			String keepCancel = request.getParameter("KEEPCANCEL");
			if (keepCancel == null)
				keepCancel = "";
			forwardUrl += "&keepCancel=" + keepCancel;
			String[] keepParameter = request.getParameterValues("KEEP");
			if (keepParameter != null)
				for (int i=0; i<keepParameter.length; i++)
					forwardUrl += "&KEEP=" + keepParameter[i];				
			
			// apply any subsets that were passed in....
			if (subsetKey != null && !subsetKey.equals("") && !subsetKey.equalsIgnoreCase("Rommel"))
				hrvTable.setSubset(subsetKey, subsetLoc);
			else if (subsetParameter != null && !subsetParameter.equalsIgnoreCase("Rommel"))
					hrvTable.setSubsetWithWhereClause(subsetParameter);
				
			// apply a column to highlight if it was passed in.
			if (colHighlt != null && !colHighlt.equals(""))
				hrvTable.setHighlightedColumn(colHighlt);
			// forward to self to get going.
			forwardURL(forwardUrl,out,request,response);
		}
		catch( RemoteSasException e )
		{
			out.println( "<HTML><HEAD>" );
			out.println( "</head>" );
			out.println( "<body class=\"bodyContents\">" );
			out.println( "<table width=\"100%\" height=\"100%\" cellspacing=\"20\"><tr><td>" );
			out.println( "<p>"+vM.getSentence( "ConnectionNoAccess" )+"</p>" );
			out.println( "<p>"+vM.getSentence( "ContactSysAdmin" )+"</p>" );
			out.println( "</td></tr></table></body></html>" );
			return;
		}
		catch (ConnectionErrorException e) {
			out.println( "<HTML><HEAD>" );
			out.println( "</head>" );
			out.println( "<body class=\"bodyContents\">" );
			out.println( "<table width=\"100%\" height=\"100%\" cellspacing=\"20\"><tr><td>" );
			out.println("<p>" + vM.getLabel("ConnectionError") + "</p>");				
			out.println( "</td></tr></table></body></html>" );
			return;
		}
		catch(SecSubNotApplicableException e )
		{
			out.println( "<HTML><HEAD>" );
			out.println( "</head>" );
			out.println( "<body class=\"bodyContents\">" );
			out.println( "<table width=\"100%\" height=\"100%\" cellspacing=\"20\">" );
			out.println( "<tr><td align=\"center\">" + vM.getLabel("SecSubNotAppl") + "</td></tr>" );
			out.println( "</table></body></html>" );
			return;
		}
		catch( Exception e )
		{
			String msg = e.toString();

			out.println( "<HTML><HEAD>" );
			out.println( "</head>" );
			out.println( "<body class=\"bodyContents\">" );
			out.println( "<table width=\"100%\" height=\"100%\" cellspacing=\"20\">" );
			out.println( "<tr><td align=\"center\">"+msg+"</td></tr>" );
			out.println( "</table></body></html>" );
			return;
		}
	}
	else {
		// get parameters to modify the data set model with.
		// keep parameter (which columns are displayed).
		String keepCancel = request.getParameter("KEEPCANCEL");
		if (keepCancel == null)
			keepCancel = "";
		String[] keepParameter = request.getParameterValues("KEEP");
		
		
		
		
		String subType = "";
		
		
		
		if (clear.equalsIgnoreCase("cols")){
			//need to cut the button off...
			hrvTable.setColumnToFalse();
			hrvTable.setColumns(null);
		}
		else{
			if (keepParameter != null && !keepCancel.equalsIgnoreCase("cancel")){
				hrvTable.setColumns(keepParameter);
				hrvTable.setColumnToTrue();
			}
		}
		
		//### maperr 4/15/2004 if this is the first load, we need to hide the masked items ###
		if((keepParameter == null) && !keepCancel.equalsIgnoreCase("cancel")){
			String [] persistedColumns = hrvTable.getPersistedColumns();
			hrvTable.setColumnToFalse();
			hrvTable.setColumns(persistedColumns);
		}
		
		
		
		
		//### maperr 4/15/2004 to persist column order ##################
		String persistSelections = request.getParameter("persistColumn");
		if(persistSelections != null){
			hrvTable.updateTableOrdering(keepParameter);
			hrvTable.setColumnToFalse();
		}
		
		
		hrvTable.setMaxRows(rows);

		// subset parameter (typical where clause).
		String subsetCancel = request.getParameter("SUBSETCANCEL");
		if (subsetCancel == null)
			subsetCancel = "";
		// find parameter (self explanitory).
		String findParameter = request.getParameter("FIND");	
		
		boolean useClause = true;

		if (subsetKey != null && !subsetKey.equalsIgnoreCase("") && !subsetCancel.equals(
		"cancel") && !clear.equalsIgnoreCase("all")) {
			// apply the subset key (where clause via a key).
			hrvTable.setSubset(subsetKey, subsetLoc);
			subType = "whereKey";
			useClause = false;
		}
		if (findParameter != null && !findParameter.equalsIgnoreCase("") && !
		clear.equalsIgnoreCase("find") && !clear.equalsIgnoreCase("all")) {
			// apply the find clause (via a key).
			String findLoc = request.getParameter("findLoc");
			if (findLoc == null || findLoc.equals(""))
				hrvTable.setFind(findParameter);
			else
				hrvTable.setFind(findParameter, findLoc);
			subType = "findKey";
			useClause = false;
		}
		else if (findParameter != null && findParameter.equals("")) {
			hrvTable.setFind("");
		}
		if (useClause) {
			// set the where clause type subset (via a regular where clause).
			if (subsetParameter != null && !subsetParameter.equalsIgnoreCase("Rommel") && !subsetCancel.equals("cancel")) {
				hrvTable.setSubsetWithWhereClause(subsetParameter);
				subType = "where";
			}
		}
		
		// clear out the rows if necessary.
		if (clear.equalsIgnoreCase("rows") || clear.equalsIgnoreCase("all") && hrvTable.isSubsetParameterSet()) {
			hrvTable.setSubset(null);
			hrvTable.setSubsetWithWhereClause(null);
		}
			
		if (clear.equalsIgnoreCase("find") || clear.equalsIgnoreCase("all") && (hrvTable.isIndexVarPresent() && hrvTable.isWhereParameterSet()))
			hrvTable.setFind(null);
	
		// now display it.
%>

<HTML>
<HEAD>
	<%@ include file="HRVHeadInclude.jsp"%>
	<SCRIPT LANGUAGE="javaScript">
	   self.focus();
	</SCRIPT> 
</HEAD>

<%
	if (noTitle != null && noTitle.toUpperCase().equals("TRUE")) 
		forwardURL(vM.getLink("TBVbody") + "?CURRENTVIEW=" + tempView + "&style=" + style + "&ctrlButtons=" + ctrlButtons + "&hideWhere=" + hideWhere + "&eep=" + eep, out, request, response);
	else {
		// only bother with a buttons frame if needed.
		String buttonFrameDim = "";
		if (hrvTable.isThereANavBar() || ctrlButtons.equalsIgnoreCase("true") || radioButtons.equalsIgnoreCase("true")) {
			// determine the button frame height.
			String buttonNavFrameHeight  = (String)hrvi.getConfigValue( "button.nav.frame.height" );
			if( buttonNavFrameHeight == null || buttonNavFrameHeight.length() <= 0 )
				buttonNavFrameHeight = "75";

			buttonFrameDim = "," + buttonNavFrameHeight;
		}
%>

<FRAMESET ID="tableFS" ROWS="30,*<%=buttonFrameDim%>" BORDER=0 onunload="if (parent.BANNER.unloadFlag == true) javascript:parent.BANNER.doClose()">
	<FRAME NAME="TBVtitle" scrolling=no marginheight="0" marginwidth="0" NORESIZE

<%	
		out.println( "SRC=\"../Jsp/tableTitle.jsp?title=" + java.net.URLEncoder.encode(hrvTable.getTableDescription()) + "&style=" + style + "\">");
%>
	<FRAME NAME="TBVbody" scrolling=yes

<%	
		out.println( "SRC=\"../Jsp/tableBody.jsp?CURRENTVIEW=" + currentView + "&style=" + style + "&ctrlButtons=" + ctrlButtons + "&viewOnly=" + viewOnly + "&hideWhere=" + hideWhere  + "&key=" + tableNameParameter + "&location=" + location + "&jumpToRow=" + jumpToRow + "\">");
	
		if (hrvTable.isThereANavBar() || ctrlButtons.equalsIgnoreCase("true") || radioButtons.equalsIgnoreCase("true")) {
%>

	<FRAME NAME="TBVbuttons" scrolling=auto marginheight="0" marginwidth="0" NORESIZE

<%	
			out.println( "SRC=\"../Jsp/tableButtons.jsp?CURRENTVIEW=" + currentView + "&style=" + style + "&ctrlButtons=" + ctrlButtons + "&viewOnly=" + viewOnly + "&hideWhere=" + hideWhere + passOnSubset + "&key=" + tableNameParameter + "&location=" + location + "\">");
		}
%>

</FRAMESET>

<%
	}
	if (hrvTable != null)
	{
		hrvTable.resetTempMetaKey();
	}
%>
</HTML>

<%	
	}
%>
