<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     tableViewerColumnSubset.jsp
// AUTHOR:   sasjs1 - Jeff Schrilla
// SUPPORT:  sasjs1 - Jeff Schrilla
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  Display a SAS table.
//
//	required parameters:
//		CURRENTVIEW - the view of the table that is being displayed.
//		style - the style value to pass back to tableBody.jsp.
//		ctrlButtons - determines whether control buttons will be displayed in
//						  tableBody.jsp.
//
/*********************************************************************/
%>

<%@page import="java.io.*,java.util.*,java.lang.Object" %>
<%@page import="com.sas.sasserver.dataset.*"%>
<%@page import="com.sas.hrv.*" %>
<%@include file="HRVLoginInclude.jsp"%>

<HTML>
<HEAD>
<%@ include file="HRVHeadInclude.jsp"%>
</HEAD>
<BODY class="bodyContents">

<SCRIPT Language='JavaScript'>
	function hilite () {
		for (i=0; i<colSubsetForm.KEEP.length; i++) {
			colSubsetForm.KEEP[i].selected=true;
		}
	}
</SCRIPT>

<%
	// fetch the TableCtrl object.
	String currentView = request.getParameter("CURRENTVIEW");
	if (currentView == null)
		currentView = "";
	TableCtrl hrvTable = (TableCtrl) hrvi.getSessionValue(session, "TABLE_" + currentView);
	DataSetInterface dataSet = hrvTable.getDataSetInterface();
%>

<BR><BR><center><H1><%=hrvTable.getTableDescription()%></H1></center>

<FORM ACTION=../Jsp/openTable.jsp TARGET="_parent" NAME="colSubsetForm">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<tr>
<td valign="center" align="center">
<table nowrap border="0" cellpadding="0" cellspacing="0" class="entrybox">
<tr><td>

<%
	// get the message system.
	VisMsg vM = VisMsg.getInstance(session);
	String persist = vM.getLabel("TCSPersistSelection");

	String key = request.getParameter("key");
	if (key == null)
		key = "";
	String location = request.getParameter("location");
	if (location == null)
		location = "";

	String alpha = request.getParameter("alpha");
	boolean alphabetize = false;
	if (alpha != null && alpha.equals("y"))
		alphabetize = true;

	// get the column labels.
	//Object[] colLabels = dataSet.getColumnLabels(1,dataSet.getColumnCount());

	//if we launch this other than the standard way (hrvision explorer) these columns may not be set.
	HashMap columnMap = hrvTable.getColumnMap();
	if(columnMap == null){
	    hrvTable.getPersistedColumns();
		columnMap = hrvTable.getColumnMap();
	}

	boolean isPublic = hrvTable.isPublic();

	// set up the master label/name list.
	NamedList varListLabels = (NamedList) hrvi.getSessionValue(session, "varListLabels_" + currentView);
	NamedList varListNoLabels = (NamedList) hrvi.getSessionValue(session, "varListNoLabels_" + currentView);
	if (varListLabels == null) {
		// this is the first time in, so set up the master list only once.
		varListLabels = new NamedList();
		varListNoLabels = new NamedList();
		String colName = "";
		String colLabel = "";
		for (Iterator i = columnMap.keySet().iterator(); i.hasNext();) {
			colName = (String)i.next();
			colName = colName.toUpperCase();
			colLabel = (String)columnMap.get(colName);
			varListLabels.add(colName, colLabel);
			// now make one that has only the var names in it.
			varListNoLabels.add(colName, colName);
		}
		// now save them for future use.
		hrvi.setSessionValue(session, "varListLabels_" + currentView, varListLabels);
		hrvi.setSessionValue(session, "varListNoLabels_" + currentView, varListNoLabels);
	}

	NamedList varList = new NamedList();
	if (!hrvTable.getUseColumnHeadings()) {
		// labels are turned off, so use the varListNoLabels list.
		varList = varListNoLabels.copy();
	}
	else {
		// labels are turned on, so use the varListLabels list.
		varList = varListLabels.copy();
	}

	// now set up a List containing the vars that are currently being "kept".
	List currentVarList = new ArrayList();
	NamedList keptVarList = new NamedList();
	// get them from the url first.  If not there, then get from the table.
	String keptVars [] = request.getParameterValues("KEEP");

	if (keptVars == null && !alphabetize){
		 keptVars = hrvTable.getColumns();
	}
	if (keptVars == null && !alphabetize) {
		// since a table has to have some columns, a null must mean that all cols are displayed
		// unless alphabetize has been mashed.
		keptVarList = varList.copy();
	}
	else {
		if (keptVars != null) {
			for (int j=0; j < keptVars.length; j++) {
				currentVarList.add(keptVars[j].toUpperCase());
				keptVarList.add(keptVars[j], varList.getValue(keptVars[j]));
			}
		}
	}

	// now adjust the varlist to remove the kept vars creating the hiddenVarList.
	NamedList hiddenVarList = varList.copy();
	for (int i=hiddenVarList.size()-1; i>=0; i--) {
		if (keptVarList.getValue(hiddenVarList.getName(i)) != null)
			hiddenVarList.remove(i);
	}




	SelectorCtrl selCtrlPub = new SelectorCtrl(session);
	// required setting for proper display
	selCtrlPub.setSourceList( hiddenVarList );
	selCtrlPub.setTargetList( keptVarList );
	selCtrlPub.setSourceName( "allCols" );
	selCtrlPub.setTargetName( "KEEP" );
	selCtrlPub.setFormName( "colSubsetForm" );
	selCtrlPub.enableTargetOrdering(true);
	selCtrlPub.alphabetizeSource(alphabetize);

	// set if you want headers displayed
	selCtrlPub.setSourceHeader(vM.getLabel("TCSNotDisplayedColumns"));
	selCtrlPub.setTargetHeader(vM.getLabel("TCSDisplayedColumns"));

	//    both selectors should call...
	selCtrlPub.setFormTagEnabled( false );     // default is true - write <form> tag
	//    the second selector should call...
	//selCtrlPub.setJavaScriptEnabled( false );  // default is true - write java script

	// for testing, it is good practice to include an id unique to the page
	// but the SelectorCtrl doesn't do anything with these
	selCtrlPub.setSourceId( "colSelSrcId" );
	selCtrlPub.setTargetId( "KEEP" );

	// draws the selector to the screen
	selCtrlPub.write( out );

	// hidden variables.
	out.println("<input type=hidden name=\"CURRENTVIEW\" value=\"" + currentView + "\">");
	out.println("<input type=hidden name=\"style\" value=\"" + request.getParameter("style") + "\">");
	out.println("<input type=hidden name=\"ctrlButtons\" value=\"" + request.getParameter("ctrlButtons") + "\">");
	out.println("<input type=hidden name=\"KEEPCANCEL\" value=\"\">");
	out.println("<input type=hidden name=\"key\" value=\"" + key + "\">");
	out.println("<input type=hidden name=\"location\" value=\"" + location + "\">");
	out.println("<input type=hidden name=\"alpha\" value=\"\">");
	out.println("<input type=hidden name=\"fromSubset\" value=\"Y\">");
%>
</td>
</tr>

<%
	if(hrvi.isUserAdmin(session) || !isPublic){
%>
<tr>
<td>

	<input type="checkbox" id="persistItem" name="persistColumn">
	<label for="persistItem"><%=persist%></label>
</td>
</tr>
<%
	}
%>
</table>
</td>
</tr>
</table></FORM>

</BODY>
</HTML>