<%@page import="java.io.*,java.util.*" %>
<%@page import="java.net.URLEncoder" %>
<%@page import="com.sas.hrv.*" %>

<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     userPrompt.jsp
// AUTHOR:   cahadd - Casey Hadden
// SUPPORT:  cahadd - Casey Hadden
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  Frame jsp to set up userprompts
//
// HISTORY:   Date    Who  Action
//           -------------------------------------------------------
//           09May01  jch  initially created
//
// NOTE:
// 		This page acts as a sort of clearing house for all the
//		user prompt JSPs. Now anyone can call this and be forwarded
//		to the correct page.
/*********************************************************************/
%>
<%@ include file="HRVLoginInclude.jsp"%>

<%
	String returnUrl = (String)session.getAttribute ("returnURL");
	String command = request.getParameter ("command");

	if (null != returnUrl) {
		session.setAttribute ("returnUrl", returnUrl);
	} else {
		returnUrl = (String)session.getAttribute ("returnUrl");
	}

	if (returnUrl.toUpperCase ().indexOf ("SESSIONKEY") > 0) {
%>

<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ include file="../Query/QueryInclude.jsp" %>

<%
	}
%>


<%
	String queryString = "";


/*	String sessionTable = request.getParameter ("table");
	String sessionkey = request.getParameter ("sessionkey");
 	String errMsg = request.getParameter ("errMsg");

	if (sessionTable != null)
	 	queryString += "table=" + sessionTable;
	if (sessionkey != null)
		queryString += "&sessionkey=" + sessionkey;
	if (errMsg != null)
		queryString += "&errMsg=" + errMsg;*/

	queryString += "&from=" + request.getParameter("from") + "&";

	Enumeration enum = request.getParameterNames ();
	while (enum.hasMoreElements ()) {

		String thisElement = (String)enum.nextElement ();
		String [] thisElementValues = request.getParameterValues (thisElement);

		for (int i = 0; i < thisElementValues.length; i++) {
			queryString += thisElement + "=" + thisElementValues[i] + "&";
		}
	}

	VisMsg vM = VisMsg.getInstance (session);

	// if saving then create new userprompt
	if (command.equalsIgnoreCase ("SAVE")) {

		UserPromptBean thisPrompt = new UserPromptBean (session);
		int location = 2;
		if (HrvInfo.isUserAdmin (session)) {
			location = 1;
		}
		thisPrompt.setMetaLocation (location);

		String thisKey = request.getParameter ("key");
		if (thisKey == null || thisKey.equals ("") || thisKey.equalsIgnoreCase ("null")) {
			thisKey = thisPrompt.getNewMetaKey ();
		}
		thisPrompt.setMetaKey (thisKey);

		thisPrompt.save (request);

		// test the existence of the description field.
		String desc = request.getParameter ("desc");
		if (desc == null || (desc != null && desc.equals (""))) {
//			String queryString = request.getQueryString ();
			String userPromptString = "USERPROMPT_CREATE";
			returnUrl = vM.getLink (userPromptString);
			returnUrl += "?command=EDIT&key=" + thisKey + "&removeOnCancel=Y&errmsg=UPcreate_nodesc";
		}

	} else if (command.equalsIgnoreCase ("CANCEL")) {
		String removeOnCancel = request.getParameter ("removeOnCancel");
		// if we need to remove the item upon cancellation
		if (removeOnCancel != null && removeOnCancel.equals ("Y")) {
			// get the key
			String key = request.getParameter ("key");

			// create the bean.
			UserPromptBean prompt = new UserPromptBean (session);

			int location = MetaBean.PRIVATE_LOC;
			if (HrvInfo.isUserAdmin (session)) {
				location = MetaBean.PUBLIC_LOC;
			}

			prompt.setMetaLocation (location);
			prompt.setMetaKey (key);

			// remove the item.
			prompt.removeItem ();
		}
		// do nothing, it should forward automagically back to where we need to go
	} else if (command.equalsIgnoreCase ("ERROR")) {
		// do nothing, let it go back to the previous screen.
	} else if (!command.equalsIgnoreCase ("SUBMIT")) {
	// if not ready to submit code the we've got to go somewhere else
		String userPromptString = "USERPROMPT_" + command;
		returnUrl = vM.getLink (userPromptString);

//		String queryString = request.getQueryString ();

		returnUrl += "?" + queryString;

		if (command.equalsIgnoreCase ("RUN")) {
			Vector userPromptVector = (Vector)session.getAttribute ("userPromptVector");
			Vector userPromptLocationVector;
			// if the userprompt vector isn't created yet, let's make it
			if (userPromptVector == null || (userPromptVector != null && userPromptVector.size() == 0)) {
				TableBean thisTable;
				String tableKey;
				int location;

				String sessionTableName = request.getParameter ("table");

				// if table is there, then we're coming from Brian
				if (sessionTableName != null) {
					thisTable = (TableBean)session.getAttribute (sessionTableName);
				} else {
					tableKey = request.getParameter ("key");
					thisTable = new TableBean (session);
					thisTable.setMetaKey (tableKey);

					location = TableBean.PUBLIC_LOC;
					if (!HrvInfo.isUserAdmin (session)) {
						location = TableBean.PRIVATE_LOC;
					}

					thisTable.setMetaLocation (location);
				}

				// have our vector, figure out the userprompt situation
				userPromptVector = new Vector ();
				userPromptLocationVector = new Vector ();
				thisTable.userPromptWalk (userPromptVector, userPromptLocationVector);

				session.setAttribute ("userPromptVector", userPromptVector);
				session.setAttribute ("userPromptLocationVector", userPromptLocationVector);
			}
		}
	} else {
	// if submitting, then submit the macros, then go back to where we came from
   		UserPromptDisplay userPrompt = (UserPromptDisplay)session.getAttribute ("userPromptDisplay");

		try {
			//if dummy, do not submit macro value, but still refresh underlying tables
			if(!userPrompt.useDummyPrompt())
			    userPrompt.submitMacro (request);

			// refresh table here?
			TableBean thisTable = (TableBean)session.getAttribute ("currentTable");
			String from = request.getParameter("from");
			if (from != null && from.equalsIgnoreCase("open"))
			{
			    thisTable.setFromOpen(true);
			}
			else
			{
			    thisTable.setFromOpen(false);
			}
			thisTable.refreshItem();


			// get the vector
			Vector userPromptVector = (Vector)session.getAttribute ("userPromptVector");
			Vector userPromptLocationVector = (Vector)session.getAttribute ("userPromptLocationVector");

			// if still tables left then go back to run them
			if (userPromptVector != null && userPromptVector.size() > 0) {
				String userPromptString = "USERPROMPT_RUN";
				returnUrl = vM.getLink (userPromptString) + "?" +  queryString;
//				returnUrl = vM.getLink (userPromptString) + "?" +  request.getQueryString ();
			} else if (userPromptVector != null && userPromptVector.size () == 0) {
				session.removeAttribute ("userPromptVector");
				session.removeAttribute ("userPromptLocationVector");
			}
		} catch (NumberFormatException e) {

			boolean query = false;
			if (returnUrl.toUpperCase ().indexOf ("SESSIONKEY") >= 0) {
				query = true;
			}

			returnUrl = vM.getLink ("USERPROMPT_RUN");
			returnUrl += "?errMsg=" + URLEncoder.encode (vM.getLabel ("UPrun_numericformat"));

			if (query == true)
				returnUrl += "&sessionkey=" + request.getParameter ("sessionkey");
		}
		session.removeAttribute("currentTable");
	}

	forwardURL (returnUrl, out, request, response);
%>