<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.query.parser.HRVParser"%>
<%@ page import="com.sas.rmi.Connection" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%
////////////////////////////////////////////////////////////////////////////////
// Initialize variables and flags
////////////////////////////////////////////////////////////////////////////////
   //Get the resource bundle for JspQuery
   VisMsg bundle = VisMsg.getInstance(session, "com.sas.query.JSPQuery");	//resource bundle
   request.setAttribute("resources", bundle);				//save it for later

////////////////////////////////////////////////////////////////////////////////
// VALIDATE QUERY
//
// Now that we're able to save from multiple steps, we should check to see
// if the query has enough info to make this worthwhile...
////////////////////////////////////////////////////////////////////////////////
   if (m_query.getResultItemCount() == 0) {
      HashMap riders = new HashMap();
      riders.put("sessionkey", m_sessionKey);

      riders.put("msg", "NoResultItems.txt");
      String nextURL = getRedirectURL(bundle, "display", riders);

      //send URL redirect to browser and stop processing
      response.sendRedirect(response.encodeRedirectURL(nextURL));
      return;
   }

   TableBean origBean = m_query.getOriginalTableBean();			//the original TableBean
   TableBean tempBean = m_query.getWorkingTableBean();			//the working TableBean

   boolean newTable = true;		//a flag for whether this is a new table or an edit
   boolean fromProps = false;		//if edit, whether this is from the property sheet or explorer

   //There are 3 situations to check:
   //////////////////////////////////////////////////////////////////////
   // 1) New Query
   //	origBean == null
   // 2) Edit from Explorer
   //	session attribute [m_sessionKey+".fromProps"] == Boolean.FALSE
   // 3) Edit from Property Sheet
   //	session attribute [m_sessionKey+".fromProps"] == Boolean.TRUE
   //////////////////////////////////////////////////////////////////////

   //Check to see whether this is an original or an edit
   if (origBean == null) {
      //this is a new, original query.  create a new TableBean to act as original.
      origBean = new TableBean(session);
      origBean.setMetaLocation(tempBean.getMetaLocation());
      //copy the working meta data to its new location in permanent storage - save key for later
      origBean.setMetaKey(tempBean.copyItem(origBean.getMetaLocation()));
      origBean.setUser(hrvi.getUser(session));	//BKD:NOTE - I don't know if this is necessary
      m_query.initTableBean(origBean);	//BKD:FIX - shouldn't have to do this!
//System.out.println ("saving: new bean - key="+origBean.getMetaKey());	//BKD:DEBUG
   } else {
      //this was an edit to an existing query.  start by setting the proper flags.
      newTable = false;
      //it is possible that the query editor was called from the properties
      //sheet instead of the explorer.  in that case, origBean will be a
      //temporary TableBean and origBean will be the same instance as tempBean
      Boolean fpVal = (Boolean)hrvi.getSessionValue(session, m_sessionKey + ".fromProps");
      fromProps = fpVal.booleanValue();
//System.out.println ("saving: old bean - key="+origBean.getMetaKey());	//BKD:DEBUG
   }
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Create/Update physical data
////////////////////////////////////////////////////////////////////////////////
   //We want to create/update the physical data when saving the results of a query.  For that we
   // will need the SAS code and a connection to the database.

   //get the sas source code for the query
   String sasSourceCode = m_query.getTableBeanSasSource(origBean, tempBean.getMetaKey());

   ConnectionInterface cI = ConnectionInterface.getInstance(session);
   cI.submit("/* ////////////////////////////////////////////////////////////////////// */\n/* Query facility is creating/updating table " + origBean.getMetaKey() + " */\n");	//BKD:DEBUG

   Date rightNow = new Date(System.currentTimeMillis());	//current time

   //###################### maperr 4/14/2004 need to modify this source#####################
   int whereIndex = sasSourceCode.indexOf("WHERE");
   if(whereIndex != -1){
   	//need to substitute the new where
   	String front = sasSourceCode.substring(0,whereIndex);

	HashMap filterMap = (HashMap)session.getAttribute(tempBean.getMetaKey());
   	String uiWhere = (String)filterMap.get("_snapshot");

   	String ordering = (String)filterMap.get("orderandgroup");
   	if(ordering == null)
   		ordering = "";
   	if(uiWhere != null && !uiWhere.equals("")){
   		sasSourceCode = front + " WHERE " + uiWhere + " " + ordering + "; quit;";

   	}
   }

	if(sasSourceCode.indexOf(HRVParser.COLUMN_PREFIX) != -1){
		sasSourceCode = sasSourceCode.substring(0, sasSourceCode.indexOf(HRVParser.COLUMN_PREFIX)) + sasSourceCode.substring(sasSourceCode.indexOf(HRVParser.COLUMN_PREFIX) + HRVParser.COLUMN_PREFIX.length());
	}

	//System.out.println("Source : " + sasSourceCode);


   cI.submit(sasSourceCode);				//submit the sas code
   long runTime = System.currentTimeMillis() - rightNow.getTime();	//run time

   cI.submit("/* Done creating/updating table " + origBean.getMetaKey() + " */\n/* ////////////////////////////////////////////////////////////////////// */\n");	//BKD:DEBUG
   //cI.stop();
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Update meta data
////////////////////////////////////////////////////////////////////////////////
   //Now we will update the meta data for this query

   if (newTable) {
      //set the query attributes - sassource, querysrc, columns, and user prompts
      m_dataSource.updateTableBean(origBean, m_query);
      origBean.setAttributeValue("rundate",  rightNow.toString());
      origBean.setAttributeValue("runtime",  String.valueOf(runTime));

      origBean.write();			//Write the metadata to storage

   } else {
      //set the query attributes - sassource, querysrc, columns, and user prompts
      m_dataSource.updateTableBean(tempBean, m_query, tempBean.getMetaKey());

      String permanentKey = origBean.getMetaKey ();
      String temporaryKey = tempBean.getMetaKey ();

      String tempSource = tempBean.getAttributeValue ("sassource");

      // set up the new source to be a copy of the old one
      StringBuffer newSource = new StringBuffer (tempSource);
      // get the index of the temporary key
      int temporaryKeyIndex = newSource.toString().indexOf (temporaryKey);
      // while there are still temp keys left in the source
      while (temporaryKeyIndex >= 0) {
	 // replace this instance of temp key with perm key
	 newSource.replace (temporaryKeyIndex, temporaryKeyIndex + temporaryKey.length (), permanentKey);
	 // find the next temp key
	 temporaryKeyIndex = newSource.toString().indexOf (temporaryKey);
      }

      // set the source back to what we changed it too
      tempBean.setAttributeValue ("sassource", newSource.toString());


//BKD:TEST - Can we avoid this string based pattern matching using one or more of the SQL construction
//methods?
String testSasSource = m_query.getTableBeanSasSource(origBean, origBean.getMetaKey());

      //update the bean's run values
      tempBean.setAttributeValue("rundate",  rightNow.toString());
      tempBean.setAttributeValue("runtime",  String.valueOf(runTime));
      // write out the temp bean


      //complex
      String complex_query = (String)session.getAttribute("complex_filter_on");
      if(complex_query != null && complex_query.equals("on"))
      	tempBean.setAttributeValue("complex_query",  "on");


      tempBean.write ();
   }

   //####cleanup the session####
   session.removeAttribute(tempBean.getMetaKey());


////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Prepare to hand-off to HR Vision
////////////////////////////////////////////////////////////////////////////////
   //After saving the meta data we will send the user to the properties sheet.
   //1st, prepare the parameters to pass to the properties sheet.

   //We will always put the TableBean object for the original bean on the session using its MetaKey as the
   //session key.
   session.setAttribute(origBean.getMetaKey(), origBean);
   hrvi.setSessionValue(session, origBean.getMetaKey(), origBean);

   //When we are editing an existing query, we will put the temporary TableBean object on the session using
   //its MetaKey as the session key.
   if (!newTable) {
//System.out.println ("tempBean.isTemp (): " + tempBean.isTemp ());	//BKD:DEBUG
      session.setAttribute(tempBean.getMetaKey(), tempBean);
      hrvi.setSessionValue(session, tempBean.getMetaKey(), tempBean);
   }

   //get the global parameters from the query object.  these parameters were fed to the query facility from
   //HR Vision and stored for use here.
   Hashtable hrvParams = m_query.getHrvParameters();		//get the global parameters from HR Vision
   //the KEY value to pass back to HR Vision will depend on whether this is a new query or an edit to an
   //existing one.
   if (newTable) {
      hrvParams.put("key", origBean.getMetaKey());		//pass key of new TableBean
   } else {
      hrvParams.put("key", tempBean.getMetaKey());		//pass key of temp TableBean
   }
   hrvParams.put("properKey", origBean.getMetaKey());		//add a parameter to point to the proper key
////////////////////////////////////////////////////////////////////////////////

   //2nd, construct the URL to forward the request off to.

   //we will forward to a different page depending on whether this is a new query or an edit to an existing
   //query.
   String fwdUrl = null;	//the URL to forward the request to
   if (newTable) {
       fwdUrl = "../Jsp/propertiesItem.jsp?";			//forwarding to propertiesItem.jsp
   } else {
       fwdUrl = "../Jsp/propertiesTable.jsp?";			//forwarding to propertiesTable.jsp
   }
   fwdUrl = fwdUrl + buildParameterString(hrvParams);		//apply global parameters from HR Vision
//System.out.println ("fwdUrl: " + fwdUrl);			//BKD:DEBUG
//   pageContext.forward(fwdUrl);					//forward the request
%>
<SCRIPT LANGUAGE="JavaScript">
top.document.location.href='<%= fwdUrl %>';
</SCRIPT>
